StartTest(t => {

    //=================================================================
    t.diag("Testing asynchronous code")

    // this function performs an asynchronous addition of 1st argument to second
    let asynchronousFunction = (a, b, callback, errback) => {

        setTimeout(() => {

            let res = a + b

            if (isNaN(res)) {
                errback(res)
            } else {
                callback(res)
            }

        }, 10)
    };

    // optional when using `setTimeout`, but required for XHR requests
    let async1   = t.beginAsync()

    asynchronousFunction(1, 1, res => {

        t.is(res, 2, 'Correct result of 1 plus 1')

        // optional when using `setTimeout`, but required for XHR requests
        t.endAsync(async1)

        next()

    }, () => {
        t.fail("Should never get here")
    })


    let next = () => {

        // optional when using `setTimeout`, but required for XHR requests
        let async2   = t.beginAsync()

        asynchronousFunction(1, {}, () => {

            t.fail("Should never get here")

        }, res => {
            t.ok(isNaN(res), '1 plus {} is not a number')

            // optional when using `setTimeout`, but required for XHR requests
            t.endAsync(async2)
        })
    }

})