var harness = new Siesta.Project.Browser.ExtJS()

var log     = function(text) {
    if (window.console && console.log) {
       console.log(text);
    }
}

harness.configure({
    title     : 'Awesome Test Suite',

    preload : [
        'http://cdn.sencha.io/ext/gpl/4.2.0/resources/css/ext-all.css',
        'http://cdn.sencha.io/ext/gpl/4.2.0/ext-all-debug.js',

        'harness-events/preload.js'
    ],

    recorderConfig : {
        recorderClass : 'CustomRecorder'
    },

    // can provide single event handlers in the special "listeners" config 
    listeners : {
        testsuitestart      : function (event, harness) {
            log('Test suite is starting: ' + harness.title)
        },

        testsuiteend        : function (event, harness) {
            log('Test suite is finishing: ' + harness.title)
        },

        teststart           : function (event, test) {
            log('Test case is starting: ' + test.url)
        },

        testupdate          : function (event, test, result) {
            log('Test case [' + test.url + '] has been updated: ' + result.description + (result.annotation ? ', ' + result.annotation : ''))
        },

        testfailedwithexception : function (event, test) {
            log('Test case [' + test.url + '] has failed with exception: ' + test.failedException)
        }
    }
})

// or can subscribe manually
harness.on('testfinalize', function (event, test) {
    log('Test case [' + test.url + '] has completed')
})


harness.start(
    'harness-events/sanity.t.js',
    'harness-events/basics.t.js',
    'harness-events/custom-recorder.t.js'
)

