/*

Siesta 4.4.5
Copyright(c) 2009-2018 Bryntum AB
https://bryntum.com/contact
https://bryntum.com/products/siesta/license

*/
Role('Siesta.Project.Browser.Automation.NodeJS', {

    has : {
        isNodeJS        : false
    },

    override : {

        initialize : function () {
            if (typeof process != 'undefined') {
                this.isAutomated        = true
                this.isNodeJS           = true
            }

            this.SUPERARG(arguments)
        },


        setup : function () {
            if (this.isNodeJS && typeof AS_LAUNCHER != 'undefined') {

                this.SUPER(() => {
                    const path                          = require('path')
                    const {requirer}                    = require("./src/util/nodejs/CanRequireInContext.js")

                    //----
                    // relative to CanRequireInContext file
                    let _launcher_                      = requirer.requireInContext('../../../bin/siesta-launcher-all.js')

                    let launcher                        = new _launcher_.Siesta.Launcher.NodeJS({
                        args : [ path.resolve(__dirname, './bin'), 'NOT_USED' ].concat(process.argv.slice(1))
                    })

                    launcher.start().then(exitCode => launcher.exit(exitCode))
                })

            } else {
                const indexFile                         = process.argv[ 1 ]

                if (this.chdirToIndex) {
                    const path = require('path')

                    process.chdir(path.dirname(indexFile))
                }

                this.scopeProvider                      = 'Scope.Provider.NodeJsEmbed'

                this.SUPERARG(arguments)
            }
        }
    }
})
